package zer01hd.zer10hdbot;

import java.util.Arrays;
import java.util.List;

import javax.security.auth.login.LoginException;

import net.dv8tion.jda.core.JDA;
import net.dv8tion.jda.core.JDABuilder;
import net.dv8tion.jda.core.entities.Guild;
import net.dv8tion.jda.core.entities.Member;
import net.dv8tion.jda.core.events.Event;
import net.dv8tion.jda.core.events.ReadyEvent;
import net.dv8tion.jda.core.exceptions.RateLimitedException;
import net.dv8tion.jda.core.hooks.EventListener;
import zer01hd.zer10hdbot.listeners.MessageListener;
import zer01hd.zer10hdbot.listeners.SelfEventListener;

public class Zer10HDBot {
	public JDA jda;
	public String cmdPrefix = "`";
	
	public Zer10HDBot(JDABuilder jdab) throws LoginException, IllegalArgumentException, RateLimitedException {
		jdab.addEventListener(new EventListener() {
			public void onEvent(Event arg0) {
				if (arg0 instanceof ReadyEvent) {
					initiate();
					System.out.println("Build complete! Zer10Bot is now ready for action!");
					setupListeners();
				}
			}
		});
		connect(jdab);
	}
	public void setupListeners() {
		jda.addEventListener(new MessageListener(this), new SelfEventListener());
	}
	
	public void connect(JDABuilder jdab) throws LoginException, IllegalArgumentException, RateLimitedException {
		System.out.println("attempting build.");
		this.jda = jdab.buildAsync();
		
	}
	
	public void initiate() {
		if (jda != null) {
			List<Guild> guilds = jda.getGuilds();
			System.out.println("Connected to the following servers: " + Arrays.toString(guilds.toArray()));
		} else {
			System.out.println("JDA didn't finish building the bot yet...");
		}
	}
	
	public void tempScript() {
		Guild guild = jda.getGuildsByName("Weeabism", true).get(0);
		if (guild != null) {
			Member member = guild.getMembersByEffectiveName("Poi!?", true).get(0);
			if (member != null) {
				System.out.println(member.getUser().getId());
			}
		}
		System.out.println("heh");
	}
}
