package zer01hd.zer10hdbot.archive;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Path;

public class TextFile {
	private FileWriter fileWriter;
	private PrintWriter printWriter;
	private File file;
	private boolean append = true;
	private int messageInBatchCount;
	
	/**
	 * Default append is true
	 * A standard object to help write text files.
	 * @param file
	 */
	public TextFile(Path path, String textFileName) {
		this.file = new File(path.toString(), textFileName + ".txt");
		
		try {
			this.fileWriter = new FileWriter(file, append);
			this.printWriter = new PrintWriter(fileWriter);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public void write(String string) {
		messageInBatchCount++;
		printWriter.println(string);
		
		if (messageInBatchCount > 16) {
			flush();
		}
	}
	
	public void setAppend(boolean append) {
		closeFile();
		
		try {
			this.fileWriter = new FileWriter(file, append);
			this.printWriter = new PrintWriter(fileWriter, true);
		} catch (IOException e) {
			e.printStackTrace();
		}

		this.append = append;
	}
	
	public void closeFile() {
		try {
			flush();
			printWriter.close();
			fileWriter.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public void flush() {
		try {
			fileWriter.flush();
			messageInBatchCount = 0;
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public File getFile() {
		return file;
	}
	
	public int getMessageInBatchCount() {
		return messageInBatchCount;
	}
}
