package zer01hd.zer10hdbot.listeners;

import java.io.File;
import java.util.Calendar;
import java.util.Random;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import net.dv8tion.jda.core.entities.Message;
import net.dv8tion.jda.core.entities.MessageChannel;
import net.dv8tion.jda.core.entities.User;
import net.dv8tion.jda.core.events.message.MessageReceivedEvent;
import net.dv8tion.jda.core.hooks.ListenerAdapter;
import zer01hd.zer10hdbot.Zer10HDBot;
import zer01hd.zer10hdbot.archive.ArchiveManager;

public class MessageListener extends ListenerAdapter {
	Zer10HDBot z10b;
	ArchiveManager am;
	
	Random rand = new Random();
	public MessageListener(Zer10HDBot z10b) {
		this.z10b = z10b;
		am = new ArchiveManager();
	}
	
	@Override
	public void onMessageReceived(MessageReceivedEvent event) {
		User user = event.getAuthor();
		Message message = event.getMessage();
		MessageChannel channel = event.getChannel();
		
		String msg = message.getContent();
		
		if (event.getGuild().getId().equals("348161059175006208")) {
			am.writeToArchive(user.getId() + ":" + user.getName() + ": " + msg);

		}
		
		if (msg.equals(z10b.cmdPrefix)) {
			channel.sendMessage("Fool! Your doing it all wrong. You need an actual command after that.").queue();
		} else if (msg.startsWith(z10b.cmdPrefix)) {
			msg = msg.substring(z10b.cmdPrefix.length());
			
			if (msg.equalsIgnoreCase("roll")) {
				
				int roll = rand.nextInt(6) + 1;
				channel.sendMessage("Your roll: " + roll).queue(sentMessage -> {
					switch (roll) {
					case 2:
						channel.sendMessage("bad luck").queue();
						break;
					case 4:
						break;
					case 6:
						channel.sendMessage("nice roll!").queue();
						break;
					}
				});
			} else if (msg.equalsIgnoreCase("plan-c")) {
				channel.sendMessage("lets not do that yet...").queue();
			} else if (msg.equalsIgnoreCase("ping")) {
				channel.sendMessage("pong").queue(sentMessage -> {
					channel.sendMessage("Actual ping: " + event.getJDA().getPing()).queue();
				});
			} else if (msg.equalsIgnoreCase("tableflip")) {
				channel.sendMessage("(╯°□°）╯︵ ┻━┻").queue();
			} else if (msg.equals("self-destruct")) {
				channel.sendMessage("doesn't sound like a good idea.").queue();
			} else if (msg.equals("guess")) {
				channel.sendMessage("no").queue();
			} else if (msg.contains(" delete chain") || msg.contains(" chain delete") || msg.contains(" omae wa shindeiru")) {
				if (user.getId().equals("243501084876865536")) {
					int toDelete = 4;
					try {
						toDelete = Integer.valueOf(msg.substring(0, 2).trim());
					} catch (NumberFormatException nfe) {
					}
					int counter = 0;
					for (Message delete : channel.getIterableHistory()) {
						delete.delete().queue();
						counter++;
						try {
							Thread.sleep(1000l);
						} catch (InterruptedException e) {
							e.printStackTrace();
						}
						if (counter > toDelete) {
							break;
						}
					}
				} else {
					channel.sendMessage("You don't have enough _dark energy_!").queue();
				}
			} else if (event.getGuild().getId().equals("348161059175006208")) {

				if (msg.equalsIgnoreCase("archive validity check")) {
					channel.sendMessage("archive will be tested.").queue();
					channel.sendMessage(!am.validateArchive() ? "archive has been corrected." : "archive is valid.").queue();
				}
				if (msg.equalsIgnoreCase("archive info")) {
					channel.sendMessage("Compared archive date values (current date vs archive initiation date): \n`" + am.getCurrentDate() + " vs " + am.getTextInitDate() + "`").queue();
				}
				
				if (msg.equalsIgnoreCase("archive name")) {
					channel.sendMessage("Current archives name: `" + am.getArchive().getFile().getName() + "`").queue();
				}
				if (msg.equalsIgnoreCase("archive month")) {
					channel.sendMessage("Current archives month: `" + am.getArchive().getFile().getParentFile().getName() + "`").queue();
				}
				
				if (msg.equalsIgnoreCase("archive flush")) {
					am.getArchive().flush();
					channel.sendMessage("the archive volatile files have been written to.").queue();
				}
				
				if (msg.startsWith("archive retrieve")) {
					String date = msg.substring(16).trim();
					File archivedFile = am.obtainArchive(date);
					System.out.println();
					if (!date.isEmpty() && archivedFile != null) {
						channel.sendFile(archivedFile, null).queue();
						channel.sendMessage("Your archive has been uploaded.").queue();
					} else {
						channel.sendMessage("Error, either could not find archive for that date, or please verify the date of the archive file you would like to retrieve in the following format: yyyy/MM/dd").queue();
					}
					
				}
				
				if (msg.equalsIgnoreCase("archive batch size")) {
					channel.sendMessage("current message batch size (unflushed messages): " + am.getArchive().getMessageInBatchCount() + "\n"
							+ "Auto flushing every 16 messages in batch. Run `archive flush` (with prefix) to force flush immediately. Recommended before retrieving currently active archive.").queue();
				}
			}
			
			
		} else if (msg.toLowerCase().contains("polyjet")) {
			int msgID = rand.nextInt(5);
			
			channel.sendMessage("keyword detected.").queue(sentMessage -> {
				String preNotedMsg = null;
				switch (msgID) {
				case 0:
					preNotedMsg = "shutup";
					break;
				case 1:
					preNotedMsg = "Be quiet! we dont speak of that anymore.";
					break;
				case 2:
					Calendar dueCal = Calendar.getInstance();
					dueCal.set(2017, 7, 27, 20, 55);
					Calendar current = Calendar.getInstance();
					
					float minutes = dueCal.getTimeInMillis() - current.getTimeInMillis();
					minutes /= 1000;
					minutes /= 60;
					
					preNotedMsg = "ya ya if you stop talking about *that* ill release it in: " + minutes + " minutes";
					break;
				case 3:
					preNotedMsg = "STOP IT.";
					break;
				case 4:
					preNotedMsg = "I dare you to speak of *it* again";
					break;
				}
				channel.sendMessage("Prenoted message from Zer01HD: \"" + preNotedMsg + "\"").queue();
			});
		} else if (!user.isBot()) {
			if (event.getGuild().getId().equals("348161059175006208")) {
				int chance = rand.nextInt(16)+1;
				if (chance == 1) {
					message.addReaction(event.getGuild().getEmotesByName("Poi", false).get(0)).queue();
				}
				if (msg.toLowerCase().contains("@zer01hd")) {
//					channel.sendMessage("gone fishing :thumbsup:").queue();
				}
				if (msg.toLowerCase().contains("demon")) {
					channel.sendMessage("_cringe_").queue();
				}
				
				if (msg.toLowerCase().equals("nyanpasu")) {
					channel.sendMessage("nyanpasu!").queue();
				}
				
				if (msg.toLowerCase().contains("loli")) {
					Pattern p = Pattern.compile(".*\\b(loli|lolis|lolicon|lolicons|loliconics)\\b.*");
					Matcher m = p.matcher(msg.toLowerCase());
					if (m.matches()) {
						channel.sendMessage("https://i.imgur.com/z2DyGWj.gif").queue();
					}
				}
				
				if (msg.toLowerCase().contains("guilty") && (msg.toLowerCase().contains("rekai") || msg.toLowerCase().contains("paoda"))) {
					channel.sendMessage("indeed.").queue();
					channel.sendMessage("https://drive.google.com/file/d/1kYFs6MuyeavKF4oZ0-qjWVr3luSVzwvj/view?usp=sharing").queue();
				}
			}
			if (msg.contains("YUNYANG")) {
				int rng = rand.nextInt(2);
				switch (rng) {
				case 0:
					if (user.getId().equals("242768094773248000")) {
						channel.sendMessage("Yep, it is my duty to call you a lolicon Nichol. My programmer told me so.").queue();
						channel.sendMessage("https://i.imgur.com/z2DyGWj.gif").queue();
					} else if (user.getId().equals("139546076955803648")) {
						channel.sendMessage(". Closet lolicon. Rekai.").queue();
					} else if (user.getId().equals("243501084876865536")) {
						channel.sendMessage("Uhhh...");
					}
					break;
				case 1:
					channel.sendMessage("SIR YES SIR!").queue();
					break;
				}

			}
			if (msg.toLowerCase().contains("facepalm*")) {
				int rng = rand.nextInt(5);
				switch (rng) {
				case 0:
					channel.sendMessage("https://i.pinimg.com/originals/df/2d/a3/df2da37278e0270d873015fb5613e57a.jpg").queue();
					break;
				case 1:
					channel.sendMessage("http://i0.kym-cdn.com/photos/images/newsfeed/000/173/877/Facepalm.gif").queue();
					break;
				case 2:
					channel.sendMessage("http://animediet.net/wp-content/uploads/2010/05/kyonfacepalm.jpg").queue();
					break;
				case 3:
					channel.sendMessage("http://images5.fanpop.com/image/photos/30900000/Dawn-facepalm-a-misty-dawn-of-may-30913860-640-480.png").queue();
					break;
				case 4:
					channel.sendMessage("https://s-media-cache-ak0.pinimg.com/originals/df/2d/a3/df2da37278e0270d873015fb5613e57a.jpg").queue();
					break;
				}
			}
		}
		super.onMessageReceived(event);
	}
}
